All of lore.kernel.org
 help / color / mirror / Atom feed
From: Qu Wenruo <wqu@suse.com>
To: linux-btrfs@vger.kernel.org
Cc: fstests@vger.kernel.org, Filipe Manana <fdmanana@suse.com>
Subject: [PATCH v2 3/3] btrfs: Test if btrfs will report false ENOSPC error balancing small metadata chunk
Date: Tue, 29 Jan 2019 20:32:22 +0800	[thread overview]
Message-ID: <20190129123222.8698-3-wqu@suse.com> (raw)
In-Reply-To: <20190129123222.8698-1-wqu@suse.com>

This is a test case for a long existing bug, caused by over-estimated
metadata space_info::bytes_may_use.

There is one proposed patch for btrfs-progs to fix it, titled:
"btrfs-progs: balance: Sync the fs before balancing metadata chunks"

The test case itself is almost the same as btrfs/181, which uses small
files to bump the reserved space to trigger the false alert.

Signed-off-by: Qu Wenruo <wqu@suse.com>
Reviewed-by: Filipe Manana <fdmanana@suse.com>
---
changelog:
v2:
- Grammar and type fixes.
- Use full subcommand name for 'btrfs' command.
---
 tests/btrfs/182     | 60 +++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/182.out |  2 ++
 tests/btrfs/group   |  1 +
 3 files changed, 63 insertions(+)
 create mode 100755 tests/btrfs/182
 create mode 100644 tests/btrfs/182.out

diff --git a/tests/btrfs/182 b/tests/btrfs/182
new file mode 100755
index 000000000000..2b347011aaa8
--- /dev/null
+++ b/tests/btrfs/182
@@ -0,0 +1,60 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (C) 2019 SUSE Linux Products GmbH. All Rights Reserved.
+#
+# FS QA Test 182
+#
+# Test if balance will report false ENOSPC error
+#
+# This is a long existing bug, caused by over-estimated metadata
+# space_info::bytes_may_use.
+# There is one proposed patch for btrfs-progs to fix it, titled:
+# "btrfs-progs: balance: Sync the fs before balancing metadata chunks"
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs btrfs 
+_supported_os Linux
+_require_scratch
+
+nr_files=1024
+
+_scratch_mkfs > /dev/null
+_scratch_mount
+
+$BTRFS_UTIL_PROG subvolume create "$SCRATCH_MNT/subvol" > /dev/null
+
+# Create some small files to take up enough metadata reserved space 
+for ((i = 0; i < $nr_files; i++)) do
+	_pwrite_byte 0xcd 0 1K "$SCRATCH_MNT/subvol/file_$i" > /dev/null
+done
+
+$BTRFS_UTIL_PROG balance start -m "$SCRATCH_MNT" > /dev/null
+
+# success, all done
+echo "Silence is golden"
+status=0
+exit
diff --git a/tests/btrfs/182.out b/tests/btrfs/182.out
new file mode 100644
index 000000000000..53d28e50c68b
--- /dev/null
+++ b/tests/btrfs/182.out
@@ -0,0 +1,2 @@
+QA output created by 182
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 0db485cbe834..e32c84e4b253 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -184,3 +184,4 @@
 179 auto qgroup dangerous
 180 auto quick qgroup limit
 181 auto quick balance
+182 auto quick balance
-- 
2.20.1


      parent reply	other threads:[~2019-01-29 12:32 UTC|newest]

Thread overview: 3+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-01-29 12:32 [PATCH v2 1/3] btrfs: Test if btrfs hits EDQUOT without trying to reclaim some space Qu Wenruo
2019-01-29 12:32 ` [PATCH v3 2/3] btrfs: Test if btrfs will commit too many transactions for balance Qu Wenruo
2019-01-29 12:32 ` Qu Wenruo [this message]

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20190129123222.8698-3-wqu@suse.com \
    --to=wqu@suse.com \
    --cc=fdmanana@suse.com \
    --cc=fstests@vger.kernel.org \
    --cc=linux-btrfs@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.